#!/usr/bin/env python
# -*- coding: utf-8 -*-
#####################################################################
#
#  Jan. 2010 created by Juergen Thies (juspertor UG)
#  email: juergen.thies@juspertor.com
#  This file may free use used, copied, modified or published.
#  It can also be use under any open source license like GPL, ...
#
#####################################################################

import sys
try:
  import pylayout
  import PyQt4
except ImportError:
  import os,site
  newpath=os.environ['PATH']
  try:
    sitepack=site.getsipackages()
    for item in sitepack:
      newpath=item+"\\layout;" +newpath
      newpath=item+";"+newpath
  except:
    print "site package path not found"
  newpath=os.getcwd()+"\\layout;"+newpath
  os.putenv("PATH",newpath)  
  import pylayout
  import PyQt4
from PyQt4 import QtCore, QtGui

global pyLayoutNewWin
pyLayoutNewWin={}


class layoutWindow(QtCore.QObject):

  def __init__(self,windowType):
    QtCore.QObject.__init__(self)
    self.layoutClose=True
    self.schematicClose=True
    self.textClose=True
    if windowType=="schematic":
      self.openSchematic()
    elif windowType=="text":
      self.openText()
    else:
      self.openLayout(windowType)

   
  
  def openLayout(self,windowType):
    if self.layoutClose==False:
      return;
    if windowType=="layoutBasic":
      pylayout.project.defaultGui=False
    elif windowType=="layoutReduced":
      pylayout.project.defaultGui=False
    elif windowType=="layoutPure":
      pylayout.project.defaultGui=False
    if self.schematicClose==False:
      self.l = pylayout.project.getLayout(self.s)
    else:
      self.l = pylayout.project.newLayout()
    self.layoutClose=False;
    self.l.closed.connect(self.layoutClosed)
    self.l.executePython.connect(self.pythonMacro,QtCore.Qt.DirectConnection)
    if windowType=="layoutBasic":
      self.l.guiSetupBasic()
    elif windowType=="layoutReduced":
      self.l.guiSetupReduced()
    elif windowType=="layoutPure":
      self.l.addMouseHelp()
    pylayout.project.defaultGui=True
    # example to add own features
    '''
    self.l.setWindowTitle("PyLayoutEditor")  #set the main window title
    self.l.toolBarAdd("New Windows","Quit")   #add a own tool bar
    t=self.l.toolBarLast()		     #gets a pointer to the last added toolBar
    act=t.addAction(QtGui.QIcon(":/icons/netlisticon.png"),"linked schematic window",self.linkedSchematic)
    act=t.addAction(QtGui.QIcon(":/icons/layoutbasic.png"),"new basic window",self.newBasic)
    act=t.addAction(QtGui.QIcon(":/icons/layoutreduced.png"),"new reduced window",self.newReduced)
    act=t.addAction(QtGui.QIcon(":/icons/layoutfull.png"),"new full window",self.newFull)
    act=t.addAction("my",self.my)	     #add a new feature to the toolBar -> self.my
    m=self.l.getMenu("My-Own")		     #creates a menu menu
    m.addAction("my",self.my)		     #adds a new feature to the menu   -> self.my
    '''

  def layoutClosed(self):
    self.layoutClose=True
  
  def openSchematic(self):
    if self.schematicClose==False:
      return;
    if self.layoutClose==False:
      self.s = pylayout.project.getSchematic(self.l)
    else:
      self.s = pylayout.project.newSchematic()
    self.schematicClose=False;
    self.s.closed.connect(self.schematicClosed)
    self.s.executePython.connect(self.pythonMacro,QtCore.Qt.DirectConnection)
    # example to add own features
    '''
    self.s.toolBarAdd("New Windows","0")   #add a own tool bar
    t=self.s.toolBarLast()		     #gets a pointer to the last added toolBar
    act=t.addAction(QtGui.QIcon(":/icons/netlibraryicon.png"),"linked layout window",self.linkedLayout)
    act=t.addAction(QtGui.QIcon(":/icons/netlisticon.png"),"new schematic window",self.newSchematic)
    m=self.s.getMenu("Sheet")
    m.addAction(QtGui.QIcon(":/icons/tolayouticon.xpm"),"Copy to Layout...", self.schematicToLayout)
    '''

  def schematicClosed(self):
    self.schematicClose=True
    
  def textClosed(self):
    self.textClose=True

  def openText(self):
    if self.textClose==False:
      return;
    self.t = pylayout.textEdit();
    self.textClose=False;
    setupText(self.t)
    #self.t.closed.connect(self.textClosed)
    #self.t.executePython.connect(self.pythonMacro,QtCore.Qt.DirectConnection)
   
  def linkedSchematic(self):
    self.openSchematic()
    self.s.show()

  def linkedLayout(self):
    self.openLayout("layoutFull")
    self.l.show()
    
  #executor for python macros  
  def pythonMacro(self,code):
        #print "started\n"
	if self.layoutClose==False:
	  layout=self.l
	if self.schematicClose==False:
	  schematic=self.s
	if self.textClose==False:
	  text=self.t
	try:
	  exec( code.toAscii().data() )
	except:
	  self.openLayout("")
	  error=sys.exc_info().__str__()
	  self.l.showMessage("Python Error:",error)
	  
  # implementation if the example feature above
  '''
  def newBasic(self):
    import random;
    r=random.random()
    pyLayoutNewWin[r] = layoutWindow("layoutBasic")
    pyLayoutNewWin[r].l.show()

  def newReduced(self):
    import random;
    r=random.random()
    pyLayoutNewWin[r] = layoutWindow("layoutReduced")
    pyLayoutNewWin[r].l.show()

  def newFull(self):
    import random;
    r=random.random()
    pyLayoutNewWin[r] = layoutWindow("layoutFull")
    pyLayoutNewWin[r].l.show()

  def newSchematic(self):
    import random;
    r=random.random()
    pyLayoutNewWin[r] = layoutWindow("schematic")
    pyLayoutNewWin[r].s.show()

  def schematicToLayout(self):
    import random;
    r=random.random()
    pyLayoutNewWin[r] = layoutWindow("layoutFull")
    self.s.toLayout(pyLayoutNewWin[r].l)
    pyLayoutNewWin[r].l.show()
    pyLayoutNewWin[r].l.drawing.scaleFull()
    pyLayoutNewWin[r].l.drawing.setModifySaved()

  def my(self):
      #exclusive look for add to the desing data
      # mutexChangeGuiTryLock will make an excluvise look
      # mutexReadGuiTryLock will enable reading only
      if (self.l.drawing.mutexAddGuiTryLock()):

	#add to points, first in drawing units, second in useriunits
	self.l.drawing.point(1000,1000)
	self.l.drawing.p(30,20)
	#make a box from the previous entered points
	self.l.drawing.box()
	#scale to a full view
	self.l.drawing.scaleFull()
	#marks the desing to be changed by adding features
	#also possible: setModifyChanged(), setModifySaved()
	self.l.drawing.setModifyAdded()
	#free the datalock
	self.l.drawing.mutexAddUnlock()
	#make layer 0 invisible
	pylayout.layers.number(0).visible = False
	#updates the gui:
	#e.g. the invisible of layer 0 will result in a grey layerbutton for layer 0
	self.l.guiUpdate()
	#repaint to see the new added box
	self.l.drawing.paint()
    '''    
  

# main programm

if (QtGui.QApplication.instance()==None):
    '''
    Please uncomment the following line if you get an error starting this 
    python file on Linux with an error:
    [xcb] Unknown request in queue while dequeuing
    [xcb] Most likely this is a multi-threaded client and XInitThreads has not been called
    [xcb] Aborting, sorry about that.
    It will work on Qt >= 4.8.0. There is no fix for this bug in qt/pyqt for Qt < 4.8.0
    '''
    #QtGui.QApplication.setAttribute(QtCore.Qt.AA_X11InitThreads)
    #if (QtCore.QString(QtCore.qVersion())>QtCore.QString("4.7.4")):
    #  QtGui.QApplication.setAttribute(QtCore.Qt.AA_X11InitThreads)
    globalApp=QtGui.QApplication(sys.argv)

if __name__ == '__main__':
    pixmap = QtGui.QPixmap(":/splash")
    splashscreen = pylayout.splash(pixmap)
    splashscreen.show()
    #win = layoutWindow("text")
    win = layoutWindow("layoutFull")
    #win = layoutWindow("schematic")
    splashscreen.finish(win.l)
    win.l.show()
    sys.exit(QtGui.QApplication.instance().exec_())


